/**
 * *******************************************************************************
 *  Copyright (c) 2015-2022 Robert Bosch GmbH and others.
 * 
 *  This program and the accompanying materials are made
 *  available under the terms of the Eclipse Public License 2.0
 *  which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 *  SPDX-License-Identifier: EPL-2.0
 * 
 *     Generated using Eclipse EMF
 * 
 * *******************************************************************************
 */
package org.eclipse.app4mc.amalthea.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Data Size Unit</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * Data size units (enumeration of available units)
 * <!-- end-model-doc -->
 * @see org.eclipse.app4mc.amalthea.model.AmaltheaPackage#getDataSizeUnit()
 * @model
 * @generated
 */
public enum DataSizeUnit implements Enumerator {
	/**
	 * The '<em><b>undefined </b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #_UNDEFINED__VALUE
	 * @generated
	 * @ordered
	 */
	_UNDEFINED_(0, "_undefined_", "_undefined_"),

	/**
	 * The '<em><b>Bit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIT_VALUE
	 * @generated
	 * @ordered
	 */
	BIT(0, "bit", "bit"),

	/**
	 * The '<em><b>Kbit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KBIT_VALUE
	 * @generated
	 * @ordered
	 */
	KBIT(0, "kbit", "kbit"),

	/**
	 * The '<em><b>Mbit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MBIT_VALUE
	 * @generated
	 * @ordered
	 */
	MBIT(0, "Mbit", "Mbit"),

	/**
	 * The '<em><b>Gbit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GBIT_VALUE
	 * @generated
	 * @ordered
	 */
	GBIT(0, "Gbit", "Gbit"),

	/**
	 * The '<em><b>Tbit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TBIT_VALUE
	 * @generated
	 * @ordered
	 */
	TBIT(0, "Tbit", "Tbit"),

	/**
	 * The '<em><b>Kibit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KIBIT_VALUE
	 * @generated
	 * @ordered
	 */
	KIBIT(0, "Kibit", "Kibit"),

	/**
	 * The '<em><b>Mibit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MIBIT_VALUE
	 * @generated
	 * @ordered
	 */
	MIBIT(0, "Mibit", "Mibit"),

	/**
	 * The '<em><b>Gibit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GIBIT_VALUE
	 * @generated
	 * @ordered
	 */
	GIBIT(0, "Gibit", "Gibit"),

	/**
	 * The '<em><b>Tibit</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIBIT_VALUE
	 * @generated
	 * @ordered
	 */
	TIBIT(0, "Tibit", "Tibit"),

	/**
	 * The '<em><b>B</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #B_VALUE
	 * @generated
	 * @ordered
	 */
	B(0, "B", "B"),

	/**
	 * The '<em><b>KB</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KB_VALUE
	 * @generated
	 * @ordered
	 */
	KB(0, "kB", "kB"),

	/**
	 * The '<em><b>MB</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MB_VALUE
	 * @generated
	 * @ordered
	 */
	MB(0, "MB", "MB"),

	/**
	 * The '<em><b>GB</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GB_VALUE
	 * @generated
	 * @ordered
	 */
	GB(0, "GB", "GB"),

	/**
	 * The '<em><b>TB</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TB_VALUE
	 * @generated
	 * @ordered
	 */
	TB(0, "TB", "TB"),

	/**
	 * The '<em><b>Ki B</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KI_B_VALUE
	 * @generated
	 * @ordered
	 */
	KI_B(0, "KiB", "KiB"),

	/**
	 * The '<em><b>Mi B</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MI_B_VALUE
	 * @generated
	 * @ordered
	 */
	MI_B(0, "MiB", "MiB"),

	/**
	 * The '<em><b>Gi B</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GI_B_VALUE
	 * @generated
	 * @ordered
	 */
	GI_B(0, "GiB", "GiB"),

	/**
	 * The '<em><b>Ti B</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TI_B_VALUE
	 * @generated
	 * @ordered
	 */
	TI_B(0, "TiB", "TiB");

	/**
	 * The '<em><b>undefined </b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #_UNDEFINED_
	 * @model name="_undefined_"
	 * @generated
	 * @ordered
	 */
	public static final int _UNDEFINED__VALUE = 0;

	/**
	 * The '<em><b>Bit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIT
	 * @model name="bit"
	 * @generated
	 * @ordered
	 */
	public static final int BIT_VALUE = 0;

	/**
	 * The '<em><b>Kbit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KBIT
	 * @model name="kbit"
	 * @generated
	 * @ordered
	 */
	public static final int KBIT_VALUE = 0;

	/**
	 * The '<em><b>Mbit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MBIT
	 * @model name="Mbit"
	 * @generated
	 * @ordered
	 */
	public static final int MBIT_VALUE = 0;

	/**
	 * The '<em><b>Gbit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GBIT
	 * @model name="Gbit"
	 * @generated
	 * @ordered
	 */
	public static final int GBIT_VALUE = 0;

	/**
	 * The '<em><b>Tbit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TBIT
	 * @model name="Tbit"
	 * @generated
	 * @ordered
	 */
	public static final int TBIT_VALUE = 0;

	/**
	 * The '<em><b>Kibit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KIBIT
	 * @model name="Kibit"
	 * @generated
	 * @ordered
	 */
	public static final int KIBIT_VALUE = 0;

	/**
	 * The '<em><b>Mibit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MIBIT
	 * @model name="Mibit"
	 * @generated
	 * @ordered
	 */
	public static final int MIBIT_VALUE = 0;

	/**
	 * The '<em><b>Gibit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GIBIT
	 * @model name="Gibit"
	 * @generated
	 * @ordered
	 */
	public static final int GIBIT_VALUE = 0;

	/**
	 * The '<em><b>Tibit</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIBIT
	 * @model name="Tibit"
	 * @generated
	 * @ordered
	 */
	public static final int TIBIT_VALUE = 0;

	/**
	 * The '<em><b>B</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #B
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int B_VALUE = 0;

	/**
	 * The '<em><b>KB</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KB
	 * @model name="kB"
	 * @generated
	 * @ordered
	 */
	public static final int KB_VALUE = 0;

	/**
	 * The '<em><b>MB</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MB
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int MB_VALUE = 0;

	/**
	 * The '<em><b>GB</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GB
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int GB_VALUE = 0;

	/**
	 * The '<em><b>TB</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TB
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int TB_VALUE = 0;

	/**
	 * The '<em><b>Ki B</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KI_B
	 * @model name="KiB"
	 * @generated
	 * @ordered
	 */
	public static final int KI_B_VALUE = 0;

	/**
	 * The '<em><b>Mi B</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MI_B
	 * @model name="MiB"
	 * @generated
	 * @ordered
	 */
	public static final int MI_B_VALUE = 0;

	/**
	 * The '<em><b>Gi B</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GI_B
	 * @model name="GiB"
	 * @generated
	 * @ordered
	 */
	public static final int GI_B_VALUE = 0;

	/**
	 * The '<em><b>Ti B</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TI_B
	 * @model name="TiB"
	 * @generated
	 * @ordered
	 */
	public static final int TI_B_VALUE = 0;

	/**
	 * An array of all the '<em><b>Data Size Unit</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final DataSizeUnit[] VALUES_ARRAY =
		new DataSizeUnit[] {
			_UNDEFINED_,
			BIT,
			KBIT,
			MBIT,
			GBIT,
			TBIT,
			KIBIT,
			MIBIT,
			GIBIT,
			TIBIT,
			B,
			KB,
			MB,
			GB,
			TB,
			KI_B,
			MI_B,
			GI_B,
			TI_B,
		};

	/**
	 * A public read-only list of all the '<em><b>Data Size Unit</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<DataSizeUnit> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Data Size Unit</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static DataSizeUnit get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataSizeUnit result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Size Unit</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static DataSizeUnit getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataSizeUnit result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Size Unit</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static DataSizeUnit get(int value) {
		switch (value) {
			case _UNDEFINED__VALUE: return _UNDEFINED_;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private DataSizeUnit(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //DataSizeUnit
